
From: David Howells <dhowells@redhat.com>

The attached patch fixes the IDE driver to initialise correctly in the case
that IDE_ARCH_OBSOLETE_INIT is not defined.  Not defining this macro would
seem to be the correct thing to do since it includes the word "obsolete" in
its name.

Signed-Off-By: David Howells <dhowells@redhat.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/ide/setup-pci.c |    5 +++++
 1 files changed, 5 insertions(+)

diff -puN drivers/ide/setup-pci.c~ide_arch_obsolete_init-fix drivers/ide/setup-pci.c
--- 25/drivers/ide/setup-pci.c~ide_arch_obsolete_init-fix	Mon Nov  8 14:48:48 2004
+++ 25-akpm/drivers/ide/setup-pci.c	Mon Nov  8 14:48:48 2004
@@ -425,7 +425,12 @@ static ide_hwif_t *ide_hwif_configure(st
 	if (hwif->io_ports[IDE_DATA_OFFSET] != base ||
 	    hwif->io_ports[IDE_CONTROL_OFFSET] != (ctl | 2)) {
 		memset(&hwif->hw, 0, sizeof(hwif->hw));
+#ifndef IDE_ARCH_OBSOLETE_INIT
+		ide_std_init_ports(&hwif->hw, base, (ctl | 2));
+		hwif->hw.io_ports[IDE_IRQ_OFFSET] = 0;
+#else
 		ide_init_hwif_ports(&hwif->hw, base, (ctl | 2), NULL);
+#endif
 		memcpy(hwif->io_ports, hwif->hw.io_ports, sizeof(hwif->io_ports));
 		hwif->noprobe = !hwif->io_ports[IDE_DATA_OFFSET];
 	}
_
